#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "frasesDB.h"

static FILE *arquivo = NULL;
static char *frases = NULL;

static int getSize ()
{
  struct stat arqstat;

  stat (ARQ_FRASES, &arqstat);

  return arqstat.st_size;
}


static void openFrases ()
{
  if (! arquivo)
    arquivo = fopen (ARQ_FRASES, LEITURA);
}


static void readFrases ()
{
  int tam;

  tam = getSize();

  if (! frases)
    frases = (char *) calloc (tam + 1, sizeof (char));

  if (arquivo &&  strlen (frases) == 0)
    fread (frases, sizeof(char), tam, arquivo);
}
    
      
char *leFrase (char *tipo, char *idioma)
{
  char *inicio,
       *fim,
       *label,
       *result;

  openFrases ();
  readFrases ();

  label = (char *) calloc (strlen(tipo) + strlen(idioma) + strlen("[] = ") + 1, sizeof(char));
  strcpy (label, tipo);
  strcat (label, "[");
  strcat (label, idioma);
  strcat (label, "] = ");

  if (frases) {
    inicio = strstr (frases, label);
    inicio += strlen (label);

    fim = strstr (inicio, "] = ");
    while (*fim-- != '\n');

    result = (char *) calloc (fim - inicio + 2, sizeof (char));
    strncpy (result, inicio, fim - inicio + 1);

    return (result);

  }
}

